instaweb: allow for use of auto-generated scripts
[git/git.git] / git-instaweb.sh
CommitLineData
a51d37c1
EW
1#!/bin/sh
2#
3# Copyright (c) 2006 Eric Wong
4#
5USAGE='[--start] [--stop] [--restart]
6 [--local] [--httpd=<httpd>] [--port=<port>] [--browser=<browser>]
7 [--module-path=<path> (for Apache2 only)]'
8
9. git-sh-setup
10
b2bc9a30 11fqgitdir="$GIT_DIR"
e0d10e1c
TP
12local="`git config --bool --get instaweb.local`"
13httpd="`git config --get instaweb.httpd`"
14browser="`git config --get instaweb.browser`"
15port=`git config --get instaweb.port`
16module_path="`git config --get instaweb.modulepath`"
a51d37c1
EW
17
18conf=$GIT_DIR/gitweb/httpd.conf
19
20# Defaults:
21
82e5a82f 22# if installed, it doesn't need further configuration (module_path)
a51d37c1
EW
23test -z "$httpd" && httpd='lighttpd -f'
24
25# probably the most popular browser among gitweb users
26test -z "$browser" && browser='firefox'
27
28# any untaken local port will do...
29test -z "$port" && port=1234
30
31start_httpd () {
32 httpd_only="`echo $httpd | cut -f1 -d' '`"
33 if test "`expr index $httpd_only /`" -eq '1' || \
34 which $httpd_only >/dev/null
35 then
36 $httpd $fqgitdir/gitweb/httpd.conf
37 else
38 # many httpds are installed in /usr/sbin or /usr/local/sbin
39 # these days and those are not in most users $PATHs
14b45b66
MD
40 # in addition, we may have generated a server script
41 # in $fqgitdir/gitweb.
42 for i in /usr/local/sbin /usr/sbin "$fqgitdir/gitweb"
a51d37c1
EW
43 do
44 if test -x "$i/$httpd_only"
45 then
46 # don't quote $httpd, there can be
47 # arguments to it (-f)
48 $i/$httpd "$fqgitdir/gitweb/httpd.conf"
49 return
50 fi
51 done
f281e3a1
FK
52 echo "$httpd_only not found. Install $httpd_only or use" \
53 "--httpd to specify another http daemon."
54 exit 1
a51d37c1 55 fi
5209eda8
JS
56 if test $? != 0; then
57 echo "Could not execute http daemon $httpd."
58 exit 1
59 fi
a51d37c1
EW
60}
61
62stop_httpd () {
63 test -f "$fqgitdir/pid" && kill `cat "$fqgitdir/pid"`
64}
65
822f7c73 66while test $# != 0
a51d37c1
EW
67do
68 case "$1" in
69 --stop|stop)
70 stop_httpd
71 exit 0
72 ;;
73 --start|start)
74 start_httpd
75 exit 0
76 ;;
77 --restart|restart)
78 stop_httpd
79 start_httpd
80 exit 0
81 ;;
82 --local|-l)
83 local=true
84 ;;
85 -d|--httpd|--httpd=*)
86 case "$#,$1" in
87 *,*=*)
88 httpd=`expr "$1" : '-[^=]*=\(.*\)'` ;;
89 1,*)
90 usage ;;
91 *)
92 httpd="$2"
93 shift ;;
94 esac
95 ;;
96 -b|--browser|--browser=*)
97 case "$#,$1" in
98 *,*=*)
99 browser=`expr "$1" : '-[^=]*=\(.*\)'` ;;
100 1,*)
101 usage ;;
102 *)
103 browser="$2"
104 shift ;;
105 esac
106 ;;
107 -p|--port|--port=*)
108 case "$#,$1" in
109 *,*=*)
110 port=`expr "$1" : '-[^=]*=\(.*\)'` ;;
111 1,*)
112 usage ;;
113 *)
114 port="$2"
115 shift ;;
116 esac
117 ;;
118 -m|--module-path=*|--module-path)
119 case "$#,$1" in
120 *,*=*)
121 module_path=`expr "$1" : '-[^=]*=\(.*\)'` ;;
122 1,*)
123 usage ;;
124 *)
125 module_path="$2"
126 shift ;;
127 esac
128 ;;
129 *)
130 usage
131 ;;
132 esac
133 shift
134done
135
136mkdir -p "$GIT_DIR/gitweb/tmp"
137GIT_EXEC_PATH="`git --exec-path`"
138GIT_DIR="$fqgitdir"
139export GIT_EXEC_PATH GIT_DIR
140
141
142lighttpd_conf () {
143 cat > "$conf" <<EOF
144server.document-root = "$fqgitdir/gitweb"
145server.port = $port
146server.modules = ( "mod_cgi" )
147server.indexfiles = ( "gitweb.cgi" )
148server.pid-file = "$fqgitdir/pid"
149cgi.assign = ( ".cgi" => "" )
150mimetype.assign = ( ".css" => "text/css" )
151EOF
152 test "$local" = true && echo 'server.bind = "127.0.0.1"' >> "$conf"
153}
154
155apache2_conf () {
156 test -z "$module_path" && module_path=/usr/lib/apache2/modules
157 mkdir -p "$GIT_DIR/gitweb/logs"
158 bind=
159 test "$local" = true && bind='127.0.0.1:'
160 echo 'text/css css' > $fqgitdir/mime.types
161 cat > "$conf" <<EOF
44a167b0 162ServerName "git-instaweb"
a51d37c1
EW
163ServerRoot "$fqgitdir/gitweb"
164DocumentRoot "$fqgitdir/gitweb"
165PidFile "$fqgitdir/pid"
166Listen $bind$port
44a167b0
EW
167EOF
168
169 for mod in mime dir; do
170 if test -e $module_path/mod_${mod}.so; then
171 echo "LoadModule ${mod}_module " \
172 "$module_path/mod_${mod}.so" >> "$conf"
173 fi
174 done
175 cat >> "$conf" <<EOF
a51d37c1
EW
176TypesConfig $fqgitdir/mime.types
177DirectoryIndex gitweb.cgi
178EOF
179
180 # check to see if Dennis Stosberg's mod_perl compatibility patch
181 # (<20060621130708.Gcbc6e5c@leonov.stosberg.net>) has been applied
182 if test -f "$module_path/mod_perl.so" && grep '^our $gitbin' \
183 "$GIT_DIR/gitweb/gitweb.cgi" >/dev/null
184 then
185 # favor mod_perl if available
186 cat >> "$conf" <<EOF
187LoadModule perl_module $module_path/mod_perl.so
188PerlPassEnv GIT_DIR
189PerlPassEnv GIT_EXEC_DIR
190<Location /gitweb.cgi>
191 SetHandler perl-script
192 PerlResponseHandler ModPerl::Registry
193 PerlOptions +ParseHeaders
194 Options +ExecCGI
195</Location>
196EOF
197 else
198 # plain-old CGI
2b5d2d87 199 list_mods=`echo "$httpd" | sed "s/-f$/-l/"`
5209eda8 200 $list_mods | grep 'mod_cgi\.c' >/dev/null 2>&1 || \
2b5d2d87 201 echo "LoadModule cgi_module $module_path/mod_cgi.so" >> "$conf"
a51d37c1 202 cat >> "$conf" <<EOF
a51d37c1
EW
203AddHandler cgi-script .cgi
204<Location /gitweb.cgi>
205 Options +ExecCGI
206</Location>
207EOF
208 fi
209}
210
211script='
6ee030d6
EW
212s#^\(my\|our\) $projectroot =.*#\1 $projectroot = "'`dirname $fqgitdir`'";#
213s#\(my\|our\) $gitbin =.*#\1 $gitbin = "'$GIT_EXEC_PATH'";#
214s#\(my\|our\) $projects_list =.*#\1 $projects_list = $projectroot;#
a51d37c1
EW
215s#\(my\|our\) $git_temp =.*#\1 $git_temp = "'$fqgitdir/gitweb/tmp'";#'
216
217gitweb_cgi () {
218 cat > "$1.tmp" <<\EOFGITWEB
219@@GITWEB_CGI@@
220EOFGITWEB
221 sed "$script" "$1.tmp" > "$1"
222 chmod +x "$1"
223 rm -f "$1.tmp"
224}
225
226gitweb_css () {
227 cat > "$1" <<\EOFGITWEB
228@@GITWEB_CSS@@
229EOFGITWEB
230}
231
232gitweb_cgi $GIT_DIR/gitweb/gitweb.cgi
233gitweb_css $GIT_DIR/gitweb/gitweb.css
234
235case "$httpd" in
236*lighttpd*)
237 lighttpd_conf
238 ;;
239*apache2*)
240 apache2_conf
241 ;;
242*)
243 echo "Unknown httpd specified: $httpd"
244 exit 1
245 ;;
246esac
247
248start_httpd
249test -z "$browser" && browser=echo
5209eda8
JS
250url=http://127.0.0.1:$port
251$browser $url || echo $url